% décomposition du off axis
% calcule l'angl vertical entre direc whale et dir hydro (vertical off axis
% calcule l'angl horizontal entre direct whale et dir hydro (horiz off axis
% ce n'est pas elevation, ni azimut (à vérifier)
% HPG été 2012, contact glotin@univ-tln.fr, giraudet@univ-tln.fr
%
% Attention, précisement les valeurs d'angle seraient à attribuer aux points medians, et aux dates médianes
% on pourrait prendre les moyennes des voisins pour lisser
% à la place (différent, moins bon), on peut lisser par conv(theta, [ 1 1 1 1 1 ]) les estimations
% ici on donne les angles brutes, calculés sur les centres des vecteurs position
% 402 +1  points, les 0-5 min sont entre 

t0_5= [ 1: 95] ; t5_10  = [96 :184] ; t10_15 = [ 185:280 ] ; t15_20 = [ 281:368 ] ; t20_25 = [ 368:402 ]

load /home/glotin/vieux_dell/win_d/ENTRE_E/projets/pimc/pavi/ARCHI_SET2_BAHAMAS/SET2_POUR_JULIE/Position_baleines_set1_set2_recalculprecisfred2011/position_set2.txt

% calcul du vecteur vitesse

DP = diff(position_set2(:,4:6)) ; 

datesec = (position_set2(:,1)-1)*300 + position_set2(:,2) ;
DT = diff(datesec);

Vx = DP(:,1)./ DT;
Vy = DP(:,2)./ DT;
Vz = DP(:,3)./ DT;
V = [ Vx , Vy , Vz ] ;
nV = sqrt(sum(V'.^2));

% offaxis direct : 
B = position_set2(1:end-1,4:6) + V/2 ; %  position du centre du vecteur ( on perd un point mais centre vitesse )
nbpoints = size(B,1) ;

pos_mic=[18501.34   9494.38     -1687.63;
   10447.48    4244.37     -1677.27;
   14119.88    3034.43     -1627.08;
   16179.48    6294.09     -1672.47;
   12557.48    7471.71     -1670.99;
   17691.59    1975.28     -1633.92;
   10658.04    -14953.63   -1530.55;
   12788.99    -11897.12   -1556.14;
   14318.86    -16189.18   -1553.58;
   8672.59     -18064.35   -1361.93;
   12007.50    -19238.87   -1522.54];

for n= 7:11
Hx = pos_mic(n,1);
Hy = pos_mic(n,2);
Hz = pos_mic(n,3);

BH = ones(nbpoints,1)* [ Hx , Hy , Hz ] - B ; 
nBH = sqrt(sum((BH.^2)'));

offaxis = 180 * acos(sum((BH .* V)') ./ ( nV .* nBH) ) / pi;
% offaxisconv4 = conv(Hoffaxis, [ 1 1 1 1 ]/4);

for t = 1: nbpoints
elevation(t)=sign(Vz(t))*asin(abs(Vz(t))/nV(t))*180/pi ;
ov2(t) = asin(abs(Hz-B(t,3))/nBH(t))*180/pi;
signeov2(t)=sign(Hz-B(t,3)) ;

N = Vx(t)*(Hx-B(t,1)) + Vy(t)*(Hy-B(t,2));
D = (Vx(t)^2+Vy(t)^2)*( (Hx-B(t,1))^2 + (Hy-B(t,2))^2 );
% dg = sign(du produit scalaire de Vx(t)*(Hx-B(t,1)) avec Vy(t)*(Hy-B(t,2)))
absoffaxisHoriz(t)=acos(N/sqrt(D))*180/pi;
end 

offaxisVertic = elevation+ signeov2.*ov2 ;

figure(n)
plot(datesec(1:end-1), offaxis,'k-')
hold on ; plot(datesec(1:end-1),offaxisVertic,'m') 
hold on ; plot(datesec(1:end-1),absoffaxisHoriz,'g')
hold on ; plot(datesec(1:end-1),elevation,'r-')
hold on ; plot(datesec(1:end-1),10*nV,'b.-')
hold on ; plot(datesec(1:end-1),10*Vz,'y.-')
hold on ; plot(datesec(1:end-1),DT,'b.')
legend('offaxis','offaxisVertic', 'absoffaxisHoriz','elevation','Speed*10m/s','VSpeed*10m/s','ICI')
title(['hydro' num2str(n)])
xlabel('time in sec')
%figure(2*n)
%hist2d([abs(diff(offaxisVertic))' , nV(1:end-1)' ], 20, 20)
dates = datesec(1:end-1);
K = [ dates'; offaxis ;offaxisVertic; absoffaxisHoriz ;elevation; nV; Vz' ;DT' ];
eval(['save -ascii datesec_Hydrooffaxis_offaxisVertic_absoffaxisHoriz_elevation_vitesse_Vz_ICI_Hydro' num2str(n) '.txt K '])
K = [ dates' ;offaxisVertic ;elevation ];
eval(['save -ascii dates_offaxisVertic_elevation_per5minutes_Hydro' num2str(n) '.txt K '])
mean_offaxis =round([mean(offaxis(t0_5)) ; mean(offaxis(t5_10)) ; mean(offaxis(t10_15)) ; mean(offaxis(t15_20)) ; mean(offaxis(t20_25))]);
mean_offaxisVertic =round([mean(offaxisVertic(t0_5)) ; mean(offaxisVertic(t5_10)) ; mean(offaxisVertic(t10_15)) ; mean(offaxisVertic(t15_20)) ; mean(offaxisVertic(t20_25))]);
mean_elevation =round([mean(elevation(t0_5)) ; mean(elevation(t5_10)) ; mean(elevation(t10_15)) ; mean(elevation(t15_20)) ; mean(elevation(t20_25))])
end % hydro

